/**
 * <p>Title: Bytecode instrumentation</p>
 * <p>Description: Tracing framework for java bytecode</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Universit\u00E4t Saarbr\u00FCcken</p>
 * @author Valentin Dallmeier
 * @version 1.0
 */
package org.softevo.ample.eval;

/** An exception signalizing error conditions
 *  during trace analysis. <BR>
 */
public class AnalysisException extends Exception {

  /** Creates a new exception. <BR>
   *  @param message the message of the exception
   */
  public AnalysisException(String message) {
    super(message);
  }

  /** Creates a new exception. <BR>
   *  @param exception the exception wrapped
   */
  public AnalysisException(Throwable exception) {
    super(exception);
  }

  /** Creates a new exception. <BR>
   *  @param exception the exception wrapped
   *  @param message an additional message
   */
  public AnalysisException(String message,
                           Throwable exception) {
    super(message, exception);
  }

}
