/*
 *
 */
package org.softevo.ample.eval;

public class PatternAndWeight {

  private double patternWeight = 0;
  
  private Pattern pattern = null;

  private int failingRunsContainingPattern = 0;
  
  private int passingRunsContainingPattern = 0;
  
  /**
   * @param pattern
   * @param weight
   */
  public PatternAndWeight(Pattern pattern, double weight, int failingRunsContainingPattern, 
                          int passingRunsContainingPattern) {
    super();
    this.pattern = pattern;
    this.failingRunsContainingPattern = failingRunsContainingPattern;
    this.passingRunsContainingPattern = passingRunsContainingPattern;
    patternWeight = weight;
  }
  
  public boolean equals(Object object) {
    return ((PatternAndWeight) object).pattern.equals(pattern);
  }

  public int getFailingRunsContainingPattern() {
    return failingRunsContainingPattern;
  }

  public int getPassingRunsContainingPattern() {
    return passingRunsContainingPattern;
  }

  public Pattern getPattern() {
    return pattern;
  }

  public double getPatternWeight() {
    return patternWeight;
  }

  
}
