/*
 * Created on 22.07.2004 by Administrator
 *
 * 
 */
package org.softevo.ample.sibrelib.runtime;

import java.util.HashMap;

import org.apache.commons.lang.IntHashMap;

/**
 * @author Administrator
 *
 */
public class IncomingObjectSequenceWriter extends ObjectSequenceWriter {
  
  static {
    System.out.println("Incoming object");
    classToInstanceMapMap = new IntHashMap(500);
    classToPatternSetMap = new IntHashMap(500);
    Runtime.getRuntime().addShutdownHook(new ShutdownThread(new PatternNameWriter() {
      public String getEntityName(String mapContent, String className) {
        return mapContent.substring(className.length() + 1);
      }
    }));
    readConfiguration();
  }
  
  public static void removeInstance(int threadId, int instanceId, int classId) {
    IntHashMap classTraceMap;
    
    classTraceMap = (IntHashMap) classToInstanceMapMap.get(classId);
    if (classTraceMap != null) {
      classTraceMap.remove(instanceId);
    }
  }
  
  public static void writeEntry(int threadId, int instanceId, int classId, int methodId) {
    IntHashMap classTraceMap;
    int[] trace, copy;
    int size;
    Pattern pattern, oldPattern;
    HashMap patternMap;
    
    methodTracer.symbolCalled(methodId, classId);
    //ignore static methods
    if (instanceId != -1) {
      synchronized(lock) {
        //TODO Verify that this code can be omitted
        /*if (onlyInternal && (callerClassId == classId)) {
          return;
        }*/
        classTraceMap = getOrCreateInstanceTraceMap(classId);
        //get the trace for the instance
        trace = (int[]) classTraceMap.get(instanceId);
        //does the trace exist ?
        if (trace == null) {
          //create the int array and initialize it
          trace = new int[windowSize];
          for (int counter = 0; counter < trace.length; counter++) {
            trace[counter] = -1;
          }
          size = 0;
          classTraceMap.put(instanceId, trace);
        } else {
          //calculate the trace size
          for (size = 0; size < trace.length; size++) {
            if (trace[size] == -1) {
              break;
            }
          }
        }
        //insert at next free position
        trace[size] = methodId;
        size++;
        if (size == windowSize) {
          pattern = new Pattern();
          pattern.pattern = trace;
          patternMap = getOrCreatePatternSet(classId);
          oldPattern = (Pattern) patternMap.get(pattern);
          if (oldPattern == null) {
            //we need to copy the array to avoid side effects
            copy = new int[pattern.pattern.length];
            for (int counter = 0; counter < trace.length; counter++) {
              copy[counter] = trace[counter];
            }
            pattern.pattern = copy;
            pattern.discoveryIndex = entryCounter;
            pattern.lastOccurence = entryCounter;
            patternMap.put(pattern, pattern);
          } else {
            oldPattern.occurences++;
            oldPattern.lastOccurence = entryCounter;
          }
          for (int counter = 0; counter < trace.length - 1; counter++) {
            trace[counter] = trace[counter + 1];
          }
          trace[trace.length - 1] = -1;
        }
        entryCounter++;
      }
    }
  }
  
}