/*
 */
package org.softevo.ample.sibrelib.runtime;

import java.util.HashMap;

import org.apache.commons.lang.IntHashMap;


/**
 */
public class OutgoingClassSequenceWriter extends ClassSequenceWriter {
  
  protected static int callerInstanceId;
  
  protected static int callerClassId;
  
  static {
    System.out.println("Outgoing class");
    classToPatternSetMap = new IntHashMap(500);
    classTraceMap = new IntHashMap(500);
    Runtime.getRuntime().addShutdownHook(new ShutdownThread(new PatternNameWriter() {
      public String getEntityName(String mapContent, String className) {
        return mapContent;
      }
    }));
    readConfiguration();
  }
  
  
  public static void setCaller(int threadId, int callerInstanceId, int callerClassId) {
    OutgoingClassSequenceWriter.callerClassId = callerClassId;
    OutgoingClassSequenceWriter.callerInstanceId = callerInstanceId;
  }
  
  public static void writeEntry(int threadId, int classId, int methodId) {
    int[] trace, copy;
    int size;
    Pattern pattern, oldPattern;
    HashMap patternMap;
    
    //    System.out.println(methodId);
    methodTracer.symbolCalled(methodId, classId);
    if (callerClassId != -1) {
      trace = (int[]) classTraceMap.get(callerClassId);
      if (trace == null) {
        //create the int array and initialize it
        trace = new int[windowSize];
        for (int counter = 0; counter < trace.length; counter++) {
          trace[counter] = -1;
        }
        size = 0;
        classTraceMap.put(callerClassId, trace);
      } else {
        for (size = 0; size < trace.length; size++) {
          if (trace[size] == -1) {
            break;
          }
        }
        //insert at next free position
        trace[size] = methodId;
        size++;
        if (size == windowSize) {
          pattern = new Pattern();
          pattern.pattern = trace;
          patternMap = getOrCreatePatternSet(callerClassId);
          oldPattern = (Pattern) patternMap.get(pattern);
          if (oldPattern == null) {
            //we need to copy the array to avoid side effects
            copy = new int[pattern.pattern.length];
            for (int counter = 0; counter < trace.length; counter++) {
              copy[counter] = trace[counter];
            }
            pattern.pattern = copy;
            pattern.discoveryIndex = entryCounter;
            pattern.lastOccurence = entryCounter;
            patternMap.put(pattern, pattern);
          } else {
            oldPattern.occurences++;
            oldPattern.lastOccurence = entryCounter;
          }
          for (int counter = 0; counter < trace.length - 1; counter++) {
            trace[counter] = trace[counter + 1];
          }
          trace[trace.length - 1] = -1;
        }
        entryCounter++;
        callerClassId = -1;
      }
    } else {
      System.out.println(methodId);
    }
  }
  
}