/*
 */
package org.softevo.ample.sibrelib.runtime;

import org.apache.commons.lang.IntHashMap;
import org.softevo.ample.sibrelib.runtime.ClassSequenceWriter.ShutdownThread;
import org.softevo.ample.sibrelib.runtime.SequenceWriter.PatternNameWriter;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.OutputStreamWriter;
import java.util.HashMap;
import java.util.Iterator;

/**
 */
public class OutgoingObjectSequenceWriter extends ObjectSequenceWriter {

  private static int callerClassId = -1;
  
  private static int callerInstanceId = -1;
  
  static {
    System.out.println("Outgoing object");
    classToInstanceMapMap = new IntHashMap(500);
    classToPatternSetMap = new IntHashMap(500);
    Runtime.getRuntime().addShutdownHook(new ShutdownThread(new PatternNameWriter() {
      public String getEntityName(String mapContent, String className) {
        return mapContent;
      }
    }));
    readConfiguration();
  }

  public static void removeInstance(int threadId, int callerClassId, int instanceId) {
    IntHashMap classTraceMap;
    
    //System.out.println("Removing instance " + instanceId);
    classTraceMap = (IntHashMap) classToInstanceMapMap.get(callerClassId);
    if (classTraceMap != null) {
      classTraceMap.remove(instanceId);
    }
  }


  public static void setCaller(int threadId, int callerInstanceId, int callerClassId) {
    OutgoingObjectSequenceWriter.callerClassId = callerClassId;
    OutgoingObjectSequenceWriter.callerInstanceId = callerInstanceId;
  }
  
  public static void writeEntry(int threadId, int classId, int methodId) {
    IntHashMap classTraceMap;
    int[] trace, copy;
    int size;
    Pattern pattern, oldPattern;
    HashMap patternMap;
    
    //System.out.println(methodId);
    methodTracer.symbolCalled(methodId, classId);
    if (callerInstanceId != -1) {
      /*if (onlyInternal && (callerClassId == classId)) {
        return;
      }*/
      synchronized (lock) {
        classTraceMap = getOrCreateInstanceTraceMap(callerClassId);
        trace = (int[]) classTraceMap.get(callerInstanceId);
        if (trace == null) {
          //create the int array and initialize it
          trace = new int[windowSize];
          for (int counter = 0; counter < trace.length; counter++) {
            trace[counter] = -1;
          }
          size = 0;
          classTraceMap.put(callerInstanceId, trace);
        } else {
          for (size = 0; size < trace.length; size++) {
            if (trace[size] == -1) {
              break;
            }
          }
        }
        //insert at next free position
        trace[size] = methodId;
        size++;
        if (size == windowSize) {
          pattern = new Pattern();
          pattern.pattern = trace;
          patternMap = getOrCreatePatternSet(callerClassId);
          oldPattern = (Pattern) patternMap.get(pattern);
          if (oldPattern == null) {
            //we need to copy the array to avoid side effects
            copy = new int[pattern.pattern.length];
            for (int counter = 0; counter < trace.length; counter++) {
              copy[counter] = trace[counter];
            }
            pattern.pattern = copy;
            pattern.discoveryIndex = entryCounter;
            pattern.lastOccurence = entryCounter;
            patternMap.put(pattern, pattern);
          } else {
            oldPattern.occurences++;
            oldPattern.lastOccurence = entryCounter;
          }
          for (int counter = 0; counter < trace.length - 1; counter++) {
            trace[counter] = trace[counter + 1];
          }
          trace[trace.length - 1] = -1;
        }
        entryCounter++;
        callerClassId = -1;
        callerInstanceId = -1;
      }
    } else {
      System.out.println(methodId);
    }
  }

  
}