/*
 *
 */
package org.softevo.ample.ui;

import java.text.Collator;

import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerSorter;

public abstract class AbstractSorter extends ViewerSorter {

  protected int ascending = 0;
  
  protected int mode = 0; 
  
  public AbstractSorter(boolean ascending, int mode) {
    super();
    setAscending(ascending);
    this.mode = mode;
  }

  public void setAscending(boolean ascending) {
    if (ascending) {
      this.ascending = 1;
    } else {
      this.ascending = -1;
    }
  }
    /**
   * Returns a negative, zero, or positive number depending on whether the first element is less than, equal to, or 
   * greater than the second element.
   * 
   * @param viewer The owner viewer.
   * @param first The first element.
   * @param second The second element.
   * @return A negative number if the first element is less  than the second element; the value <code>0</code> if the 
   * first element is equal to the second element; and a positive number if the first element is greater than the 
   * second element.
   */
  public final int compare(Viewer viewer, Object first, Object second) {
    int firstCategory = category(first);
    int secondCategory = category(second);

    if (firstCategory != secondCategory) {
        return firstCategory - secondCategory;
    } else {
      return compare(first, second);
    }
  }  

  protected abstract int compare(Object first, Object second);

  public boolean getAscending() {
    if (ascending == 1) {
      return true;
    } else {
      return false;
    }
  }

  public int getMode() {
    return mode;
  }
}
