/*
 *
 */
package org.softevo.ample.ui;

import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.swt.graphics.Image;
import org.softevo.ample.eval.PatternAndWeight;
import org.softevo.ample.instrument.InstrumentationConfiguration;
import org.softevo.ample.ui.views.RankingLabelProvider;

public class PatternDifferencesLabelProvider implements ITableLabelProvider {

  private InstrumentationConfiguration config = null;
  
  public PatternDifferencesLabelProvider(InstrumentationConfiguration config) {
    super();
    this.config = config;
  }

  public Image getColumnImage(Object element, int columnIndex) {
    return null;
  }

  public String getColumnText(Object element, int columnIndex) {
    PatternAndWeight patternData;
    StringBuffer pattern;
    String[] methodNames;
   
    patternData = (PatternAndWeight) element;
    switch (columnIndex) {
      case 0: {
        return Integer.toString(patternData.getPassingRunsContainingPattern());
      }
      case 1: {
        return Integer.toString(patternData.getFailingRunsContainingPattern());
      }
      case 2: {
        return RankingLabelProvider.formatter.format(patternData.getPatternWeight());
      }
      case 3: {
        pattern = new StringBuffer();
        methodNames = patternData.getPattern().getMethodCallSequence();
        for (int counter = 0; counter < methodNames.length; counter++) {
          if (config.isOutgoingCalls()) {
            pattern.append(methodNames[counter].substring(0, methodNames[counter].lastIndexOf("#")).replace('#', '.'));
          } else {
            pattern.append(methodNames[counter].substring(0, methodNames[counter].indexOf("#")));
          }
          if (counter != methodNames.length - 1) {
            pattern.append(",");
          }
        }
        return pattern.toString();
      }
      default: {
        return null;
      }
    }
  }

  public void addListener(ILabelProviderListener listener) {
    // TODO Auto-generated method stub

  }

  public void dispose() {
    // TODO Auto-generated method stub

  }

  public boolean isLabelProperty(Object element, String property) {
    // TODO Auto-generated method stub
    return false;
  }

  public void removeListener(ILabelProviderListener listener) {
    // TODO Auto-generated method stub

  }

}
